#include <iostream>
#define N 100
#define M 100

using namespace std;

int t,n,m,a[N][M],b[N][M],nyp[N][M];

bool szegelyPont( int i, int j ){
    return i == 0 || j == 0 || i == n-1 || j == m-1;
}

bool nyeregPont( int i, int j ){
    return  !szegelyPont(i,j)
            && a[i][j] >= 0
            && a[i-1][j] >= 0 && a[i-1][j] < a[i][j]
            && a[i+1][j] >= 0 && a[i+1][j] < a[i][j]
            && a[i][j-1] > a[i][j] && a[i][j+1] > a[i][j];
}

void kiirMatrix( int a[][M] ){
    for( int i = 0 ; i < n ; ++i ){
        for( int j = 0 ; j < m ; ++j ){
            cout << a[i][j] << " ";
        }
        cout << endl;
    }
    cout << endl;
}

int main(){
    freopen("in.txt","r",stdin);
    freopen("out.txt","w",stdout);
    cin >> t;
    while ( t-- ){
        cin >> n >> m;
        for( int i = 0 ; i < n ; ++i ){
            for( int j = 0 ; j < m ; ++j ){
                cin >> a[i][j];
                b[i][j] = nyp[i][j] = 0;
            }
        }

        //kiirMatrix(a);

        for( int i = 0 ; i < n ; ++i ){
            for( int j = 0 ; j < m ; ++j ){
                if( nyeregPont(i,j) ){ nyp[i][j] = 1; }
            }
        }

        for( int i = 0 ; i < n ; ++i ){
            bool vanNyeregpont = false;
            for( int j = 0 ; j < m ; ++j ){
                if( nyp[i][j] ){ vanNyeregpont = true; }
            }
            if( vanNyeregpont ){
                for( int j = 0 ; j < m ; ++j ){
                    if( !nyp[i][j] ){ a[i][j] = -1; }
                }
            }
        }

        //kiirMatrix(nyp);

        //kiirMatrix(a);

        for( int j = 0 ; j < m ; ++j ){
            if( a[0][j] >= 0 ){ b[0][j] = 1; }
        }

        for( int i = 1 ; i < n ; ++i ){
            for( int j = 0 ; j < m ; ++j ){
                if( a[i][j] < 0 ){ continue; }
                b[i][j] += b[i-1][j];
                if( j > 0 ){ b[i][j] += b[i-1][j-1]; }
                if( j < m-1 ){ b[i][j] += b[i-1][j+1]; }
            }
        }

        //kiirMatrix(b);

        int s = 0;
        for( int j = 0 ; j < m ; ++j ){
            s += b[n-1][j];
        }

        cout << s << endl;
    }

    return 0;
}
